package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: AccountType
// UnionValue: UnknownSigner

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("UnknownSigner")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class UnknownSigner implements Account {
	public final AccountType type = AccountType.UNKNOWN_SIGNER;
	private Url url;
	private long version;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public UnknownSigner url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public UnknownSigner url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public long getVersion() {
	    return version;
	}
	public void setVersion(final long value) {
	    this.version = value;
	}

	public UnknownSigner version(final long value) {
	    setVersion(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.version == 0)) {
            marshaller.writeUint(3, this.version);
        }
        return marshaller.array();
    }
}
